/*!
 * Copyright © 2016 - present, Matthieu Jabbour <matthieu.jabbour@gmail.com>.
 * All rights reserved.
 */
module.exports=function(modules){var installedModules={};function __webpack_require__(moduleId){if(installedModules[moduleId])return installedModules[moduleId].exports;var module=installedModules[moduleId]={i:moduleId,l:!1,exports:{}};return modules[moduleId].call(module.exports,module,module.exports,__webpack_require__),module.l=!0,module.exports}return __webpack_require__.m=modules,__webpack_require__.c=installedModules,__webpack_require__.d=function(exports,name,getter){__webpack_require__.o(exports,name)||Object.defineProperty(exports,name,{configurable:!1,enumerable:!0,get:getter})},__webpack_require__.r=function(exports){Object.defineProperty(exports,"__esModule",{value:!0})},__webpack_require__.n=function(module){var getter=module&&module.__esModule?function(){return module.default}:function(){return module};return __webpack_require__.d(getter,"a",getter),getter},__webpack_require__.o=function(object,property){return Object.prototype.hasOwnProperty.call(object,property)},__webpack_require__.p="",__webpack_require__.w={},__webpack_require__(__webpack_require__.s=9)}([function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const crypto=__webpack_require__(7);exports.default=class{constructor(){this.id=crypto.randomBytes(20).toString("hex"),this.timestamp=Date.now()}setId(id){if(!/^[a-z0-9]{40}$/.test(id))throw new Error("Invalid id format.");this.id=id}getId(){return this.id}getTimestamp(){return this.timestamp}updateTimestamp(){this.timestamp=Date.now()}}},function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const Entity_1=__webpack_require__(0);exports.default=class extends Entity_1.default{constructor(){super(),this.resources=[]}addResource(resource){this.resources.includes(resource)||(this.resources.push(resource),this.updateTimestamp())}removeResource(resource){const index=this.resources.indexOf(resource);index>-1&&(this.resources.splice(index,1),this.updateTimestamp())}getResources(){return this.resources}}},function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const ResourceContainer_1=__webpack_require__(1);exports.default=class extends ResourceContainer_1.default{constructor(code){super(),this.code=code}getCode(){return this.code}setCode(code){this.code=code,this.updateTimestamp()}}},function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const Entity_1=__webpack_require__(0);class Resource extends Entity_1.default{constructor(type){super(),this.type=type,this.content=null,this.attributes={}}getType(){return this.type}getContent(){return this.content}setContent(content){this.content=content,this.updateTimestamp()}getAttributes(){return this.attributes}setAttribute(name,value){this.attributes[name]=value,this.updateTimestamp()}duplicate(){const duplicatedResource=new Resource(this.type);return Object.keys(this.attributes).forEach(attribute=>{duplicatedResource.setAttribute(attribute,this.attributes[attribute])}),null!==this.content&&duplicatedResource.setContent(this.content),duplicatedResource}}exports.default=Resource},function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const ResourceContainer_1=__webpack_require__(1);class Page extends ResourceContainer_1.default{constructor(master){super(),this.master=master||null,this.components=[]}setMaster(master){let currentMaster=master;for(;null!==currentMaster&&currentMaster.getId()!==this.id;)currentMaster=currentMaster.getMaster();if(null!==currentMaster)throw new Error("Cyclic dependencies between page masters is not allowed.");this.master=master,this.updateTimestamp()}getMaster(){return this.master}getResources(includeMaster=!0){return includeMaster&&null!==this.master?this.master.getResources(includeMaster).concat(this.resources):this.resources}addComponent(component){this.components.includes(component)||(this.components.push(component),this.updateTimestamp())}removeComponent(component){const index=this.components.indexOf(component);index>-1&&(this.components.splice(index,1),this.updateTimestamp())}getComponents(includeMaster=!0){return includeMaster&&null!==this.master?this.master.getComponents(includeMaster).concat(this.components):this.components}getText(includeMaster=!0){const componentsText=this.components.map(component=>component.getText()).join(" ");return includeMaster&&null!==this.master?`${this.master.getText(includeMaster)} ${componentsText}`.trim():componentsText.trim()}duplicate(){const duplicatedPage=new Page;return this.components.forEach(component=>{duplicatedPage.addComponent(component.duplicate())}),this.resources.forEach(resource=>{duplicatedPage.addResource(resource.duplicate())}),null!==this.master&&duplicatedPage.setMaster(this.master),duplicatedPage}}exports.default=Page},function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const ResourceContainer_1=__webpack_require__(1);class Document extends ResourceContainer_1.default{static checkName(name){if(/[\/\\\?\:<>\*\"\|]/gi.test(name))throw new Error("Document's name cannot contain the following characters : /\\?:<>*\"|")}constructor(name="new document",description=""){super(),Document.checkName(name),this.name=name,this.description=description,this.tags=[],this.authors=[],this.pages=[],this.resources=[]}setName(name){Document.checkName(name),this.name=name,this.updateTimestamp()}getName(){return this.name}setDescription(description){this.description=description,this.updateTimestamp()}getDescription(){return this.description}addTag(tag){this.tags.includes(tag)||(this.tags.push(tag),this.updateTimestamp())}removeTag(tag){const index=this.tags.indexOf(tag);index>-1&&(this.tags.splice(index,1),this.updateTimestamp())}getTags(){return this.tags}addAuthor(author){this.authors.includes(author)||(this.authors.push(author),this.updateTimestamp())}removeAuthor(author){const index=this.authors.indexOf(author);index>-1&&(this.authors.splice(index,1),this.updateTimestamp())}getAuthors(){return this.authors}getPages(){return this.pages}addPage(page){this.pages.push(page),this.updateTimestamp()}getText(){let text=this.name;return text=`${text=`${text=`${text=`${text} ${this.description}`} ${this.tags.join(" ")}`.trim()} ${this.authors.join(" ")}`.trim()} ${this.pages.map(page=>page.getText()).join("\n\n")}`}}exports.default=Document},function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const Entity_1=__webpack_require__(0);class Content extends Entity_1.default{constructor(type,markupText=""){super(),this.type=type,this.markupText=markupText}getType(){return this.type}setType(type){this.type=type,this.updateTimestamp()}getMarkupText(){return this.markupText}setMarkupText(markupText){this.markupText=markupText,this.updateTimestamp()}getText(){return this.markupText}duplicate(){return new Content(this.type,this.markupText)}}exports.default=Content},function(module,exports){module.exports=require("crypto")},function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const Entity_1=__webpack_require__(0),Template_1=__webpack_require__(2);class Component extends Entity_1.default{constructor(template,dimensions,coordinates){super(),this.contents=[],this.dimensions=dimensions||{w:0,h:0},this.coordinates=coordinates||{x:0,y:0},this.template=template||new Template_1.default("{{RICH_TEXT}}")}getContents(){return this.contents}setContentAt(index,content){for(let i=0;i<index;++i)this.contents[i]=this.contents[i]||null;this.contents[index]=content,this.updateTimestamp()}getCoordinates(){return this.coordinates}setCoordinates(coordinates){this.coordinates=coordinates,this.updateTimestamp()}getDimensions(){return this.dimensions}setDimensions(dimensions){this.dimensions=dimensions,this.updateTimestamp()}getTemplate(){return this.template}setTemplate(template){this.template=template,this.updateTimestamp()}getText(){return this.contents.filter(content=>null!==content).map(content=>content.getText()).join(" ")}duplicate(){const duplicatedComponent=new Component;return duplicatedComponent.setCoordinates(Object.assign({},this.coordinates)),duplicatedComponent.setDimensions(Object.assign({},this.dimensions)),duplicatedComponent.setTemplate(this.template),this.contents.forEach((content,index)=>{null!==content&&duplicatedComponent.setContentAt(index,content)}),duplicatedComponent}}exports.default=Component},function(module,exports,__webpack_require__){"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const Component_1=__webpack_require__(8);exports.Component=Component_1.default;const Content_1=__webpack_require__(6);exports.Content=Content_1.default;const Document_1=__webpack_require__(5);exports.Document=Document_1.default;const Page_1=__webpack_require__(4);exports.Page=Page_1.default;const Resource_1=__webpack_require__(3);exports.Resource=Resource_1.default;const Template_1=__webpack_require__(2);exports.Template=Template_1.default}]);
//# sourceMappingURL=stumpfi.js.map